<mgl-map
  (mapLoad)="handleMapLoad($event)"
  (moveEnd)="onMapMoveEnd($event)"
  [attributionControl]="false"
  [canvasContextAttributes]="funfairConfig.map.canvasContextAttributes"
  [center]="funfairConfig.map.center"
  [minZoom]="15"
  [style]="mapStyle"
  [zoom]="[15]"
>
  <mgl-control mglAttribution position="top-right"></mgl-control>
  <mgl-control [position]="'top-right'" mglNavigation></mgl-control>
  <mgl-control
    [position]="'top-right'"
    [showUserLocation]="true"
    [trackUserLocation]="true"
    mglGeolocate
  ></mgl-control>

  <ng-container *ngIf="filteredGeoJSON$ | async as filteredGeoJSON">
    <mgl-geojson-source
      [data]="filteredGeoJSON"
      id="filtered-geojson-source"
    ></mgl-geojson-source>

    <mgl-layer
      (layerClick)="onClickFeature($event)"
      [paint]="{
        'fill-color': ['get', 'fillColor'],
        'fill-opacity': ['get', 'fill-opacity'],
      }"
      id="filtered-geojson-fill-layer"
      source="filtered-geojson-source"
      type="fill"
    ></mgl-layer>

    <mgl-layer
      [paint]="{
        'line-color': ['get', 'stroke'],
        'line-width': ['get', 'stroke-width'],
        'line-opacity': ['get', 'stroke-opacity'],
      }"
      id="filtered-geojson-line-layer"
      source="filtered-geojson-source"
      type="line"
    ></mgl-layer>
  </ng-container>

  <ng-container
    *ngIf="filteredCentroidGeoJSON$ | async as filteredCentroidGeoJSON"
  >
    <mgl-geojson-source
      [data]="filteredCentroidGeoJSON"
      id="centroid-geojson-source"
    ></mgl-geojson-source>

    <mgl-layer
      (layerClick)="onClickFeature($event)"
      [filter]="['get', 'isDisabled']"
      [layout]="{
        'icon-image': ['concat', ['get', 'icon'], '-disabled'],
        'icon-size': 1 / funfairConfig.map.pixelRatio,
        'icon-allow-overlap': false,
        'icon-ignore-placement': false,
      }"
      id="inactive-centroid-layer"
      source="centroid-geojson-source"
      type="symbol"
    ></mgl-layer>

    <mgl-layer
      (layerClick)="onClickFeature($event)"
      [filter]="['!', ['get', 'isDisabled']]"
      [layout]="{
        'icon-image': ['concat', ['get', 'icon'], ''],
        'icon-size': 1 / funfairConfig.map.pixelRatio,
        'icon-allow-overlap': hasDisabledIcons,
        'icon-ignore-placement': hasDisabledIcons,
      }"
      id="active-centroid-layer"
      source="centroid-geojson-source"
      type="symbol"
    ></mgl-layer>
  </ng-container>

  <ng-container *ngIf="favoritesGeoJSON$ | async as favoritesGeoJSON">
    <mgl-geojson-source
      [data]="favoritesGeoJSON"
      id="favorites-geojson-source"
    ></mgl-geojson-source>

    <mgl-layer
      id="favorites-layer"
      source="favorites-geojson-source"
      type="symbol"
    ></mgl-layer>
  </ng-container>
</mgl-map>
